%define anolis_release 1

%undefine __cmake_in_source_build
%global _lto_cflags %{nil}
%define debug_package %{nil}

# Versions numbers
%global release_version_major    1
%global release_version_minor    0
%global release_version_rev      5
%global release_version_full   %{release_version_major}.%{release_version_minor}.%{release_version_rev}

# Interface version
%global interface_version_major  11
%global interface_version_minor  4
%global interface_version_full  %{interface_version_major}.%{interface_version_minor}

%global github_source_archive_name   ippcp_2021.6

Name:               intel-ipp-crypto-mb
Summary:            Intel(R) IPP Cryptography multi-buffer library
Release:            %{anolis_release}%{?dist}
Version:            %{release_version_full}
License:            ASL 2.0
# Upstream exclusively uses x86_64-specific intrinsics
ExclusiveArch:      x86_64
URL:                https://github.com/intel/ipp-crypto
Source0:	    https://github.com/intel/ipp-crypto/archive/refs/tags/%{github_source_archive_name}.tar.gz

BuildRequires:      coreutils
BuildRequires:      make
BuildRequires:      tar
BuildRequires:      cmake >= 3.10
BuildRequires:      openssl-devel >= 1.1.0
BuildRequires:      gcc-c++ >= 8.2

%description
A software crypto library optimized for Intel architecture for packet
processing applications.
It contains universal and OpenSSL compatible APIs for cryptography operations.

%package devel
Summary:            Intel(R) IPP Cryptography multi-buffer library (Development Files)
License:            ASL 2.0
Requires:           %{name} = %{version}-%{release}
ExclusiveArch:      x86_64

%description devel
A software crypto library optimized for Intel architecture for packet
processing applications.

It contains development libraries and header files.

For additional information please refer to:
%{github_crypto_mb_page}

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n ipp-crypto-%{github_source_archive_name} -p1

%build
cd sources/ippcp/crypto_mb
%cmake
%cmake_build
cd -

%install
cd sources/ippcp/crypto_mb
install -d %{buildroot}/%{_includedir}/crypto_mb
install -p -m 0644 -t %{buildroot}/%{_includedir}/crypto_mb include/crypto_mb/*.h
install -d %{buildroot}/%{_libdir}
install -p -s -m 0755 %{_vpath_builddir}/bin/libcrypto_mb.so.%{interface_version_full} %{buildroot}/%{_libdir}
cd %{buildroot}/%{_libdir}
ln -s libcrypto_mb.so.%{interface_version_full} libcrypto_mb.so.%{interface_version_major}
ln -s libcrypto_mb.so.%{interface_version_full} libcrypto_mb.so

%files
%license LICENSE
%{_libdir}/libcrypto_mb.so.%{interface_version_full}
%{_libdir}/libcrypto_mb.so.%{interface_version_major}

%files devel
%dir %{_includedir}/crypto_mb
%{_includedir}/crypto_mb/cpu_features.h
%{_includedir}/crypto_mb/defs.h
%{_includedir}/crypto_mb/ec_nistp256.h
%{_includedir}/crypto_mb/ec_nistp384.h
%{_includedir}/crypto_mb/ec_nistp521.h
%{_includedir}/crypto_mb/ec_sm2.h
%{_includedir}/crypto_mb/ed25519.h
%{_includedir}/crypto_mb/exp.h
%{_includedir}/crypto_mb/rsa.h
%{_includedir}/crypto_mb/sm3.h
%{_includedir}/crypto_mb/sm4.h
%{_includedir}/crypto_mb/status.h
%{_includedir}/crypto_mb/version.h
%{_includedir}/crypto_mb/x25519.h
%{_libdir}/libcrypto_mb.so

%files doc
%doc README.md DEPRECATION_NOTES.md CHANGELOG.md
%doc CONST_TIME_EXECUTION_TESTING.md SECURITY.md
%doc sources/ippcp/crypto_mb/Readme.md


%changelog
* Thu Oct 13 2022 happy_orange <songnannan@linux.alibaba.com> - 1.0.5-1
- Init pacakge from upstream
